package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.*;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {
    private List<T> list;
    private T[] inputArray;

    public ArrayUtility(T[] inputArray){
        this.list = new ArrayList<>(Arrays.asList(inputArray));
        this.inputArray = inputArray;
    }

    public void merge(T[] arrayToMerge){
        list.addAll(new ArrayList<>(Arrays.asList(arrayToMerge)));
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate){
        merge(arrayToMerge);
        return getNumberOfOccurrences(valueToEvaluate);
    }

    public T getMostCommonFromMerge(T[] arrayToMerge) {
        merge(arrayToMerge);
        int most = 0;
        T mostCommon = list.get(0);
        for (T t : list){
            int count = getNumberOfOccurrences(t);
            if (count>most) {
                most = count;
                mostCommon = t;
            }
        }
        return mostCommon;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        int count = 0;
        for (T t : list) {
            if (t.equals(valueToEvaluate)) count++;
        }
        return count;
    }

    public T[] removeValue(T valueToRemove) {
        list.removeIf(e -> e.equals(valueToRemove));

        Class tClass = inputArray.getClass();
        Class compType = tClass.getComponentType();
        T[] array = (T[]) Array.newInstance(compType,(list.size()-getNumberOfOccurrences(valueToRemove)));
        for(int i=0; i<array.length; i++)
            array[i] = list.get(i);
        return array;
    }
}
